﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace MouseClickSimulator
{
    class Program
    {
        [DllImport("user32.dll", CharSet = CharSet.Auto, CallingConvention = CallingConvention.StdCall)]
        public static extern void mouse_event(uint dwFlags, uint dx, uint dy, uint cButtons, uint dwExtraInfo);

        private const int MOUSEEVENTF_LEFTDOWN = 0x02;
        private const int MOUSEEVENTF_LEFTUP = 0x04;
        private const int MOUSEEVENTF_MIDDOWN = 0x00000020;
        private const int MOUSEEVENTF_MIDUP = 0x00000040;
        private const int MOUSEEVENTF_RIGHTDOWN = 0x08;
        private const int MOUSEEVENTF_RIGHTUP = 0x10;

        static void Main(string[] args)
        {
            string ProcessName = System.Diagnostics.Process.GetCurrentProcess().ProcessName;
            if (ProcessName == "RightClickSimulator")
                args = new string[] { "r" };
            else if (ProcessName == "MiddleClickSimulator")
                args = new string[] { "m" };

            if ((args.Length > 0) && (args[0] == "r"))
                DoMouseClick(MOUSEEVENTF_RIGHTDOWN | MOUSEEVENTF_RIGHTUP);
            else if ((args.Length > 0) && (args[0] == "m"))
                DoMouseClick(MOUSEEVENTF_MIDDOWN | MOUSEEVENTF_MIDUP);
            else
                DoMouseClick(MOUSEEVENTF_LEFTDOWN | MOUSEEVENTF_LEFTUP);
        }

        public static void DoMouseClick(uint dwFlags)
        {
            //Call the imported function with the cursor's current position
            int X = Cursor.Position.X;
            int Y = Cursor.Position.Y;
            mouse_event(dwFlags, (uint)X, (uint)Y, 0, 0);
        }
    }
}
